module.exports = {
  // 可选类型
  types: [
     { value: ':sparkles: feat', name: '✨  feat:     新功能' },
     { value: ':bug: fix', name: '🐛  fix:      修复' },
     { value: ':seedling: perf', name: '🌱  perf:     优化' },
     { value: ':art: style', name: '🎨  style:    样式调整' },
     { value: ':hammer: refactor', name: '🔨  refactor: 重构'},
     { value: ':pencil2: docs', name: '📝  docs:     文档变更' },
     { value: ':bulb: chore', name: '💡  chore:    构建过程或辅助工具的变动' },
   ],
  // 消息步骤 
  messages: {
    type: '请选择提交类型:',
    subject: '请简要描述提交(必填):',
    customScope: '请输入修改范围(可选):',
    body: '请输入详细描述(可选):',
    footer: '请输入要关闭的issue(可选):',
    confirmCommit: '确认使用以上信息提交？(y/n)'
  },
  // 跳过问题
  skipQuestions: ['body', 'footer', 'scope'],
  // subject文字长度默认是72
  subjectLimit: 72
}